//---------------------------------------------------------------------------

#include <vcl.h>
#include <vcl\Clipbrd.hpp>
#pragma hdrstop
#include <string>

#include "ClipForm.h"
#include "about.h"
#include "lang.h"
#include "setup.h"
#include "winutil.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TClipForm1 *ClipForm1;


//---------------------------------------------------------------------------
// TClipForm1
//---------------------------------------------------------------------------
__fastcall TClipForm1::TClipForm1(TComponent* Owner)
		  : TForm(Owner)
{
 HotKeySet=false;
 Hide();
 if (FileExists("active.ico"))
     ImageActive->Picture->Icon->LoadFromFile("active.ico");
 if (FileExists("inactive.ico"))
     ImageInactive->Picture->Icon->LoadFromFile("inactive.ico");
 if (FileExists("hotkey.ico"))
     ImageHotkey->Picture->Icon->LoadFromFile("hotkey.ico");
 TrayIcon_Create ((AnsiString("HovText - ") + LangText(TE_Active)).c_str(),ImageActive->Picture->Icon->Handle);
 if (GetRegInt("StartAs")==2) {
   SetActive(GetRegInt("LastState"));
 } else
 {
   SetActive(GetRegInt("StartAs")==0);
 }
 StripWS=GetRegInt("StripWS");
 StripCR=GetRegInt("StripCR");
 OnlyCopyLinks=GetRegInt("OnlyCopyLinks");

 Active1->Caption=LangText(TE_Active);
 Exit1->Caption=LangText(TE_Exit);
 About1->Caption=LangText(TE_About);
 Options1->Caption=LangText(TE_Options);
 SetHotKey();
 CF_HTML = RegisterClipboardFormat("HTML Format");
}

__fastcall TClipForm1::~TClipForm1()
{
 if (GetRegInt("StartAs")==2) {
   SetRegInt("LastState",Active1->Checked);
 }
 UnsetHotKey();
 TrayIcon_Delete();
}


//---------------------------------------------------------------------------
// Clipboard Functions:
//---------------------------------------------------------------------------

char *TClipForm1::ConvertedClipboard()
{
  static char TextBuf[60000];
  char *Startp=TextBuf;
	try {
	  TClipboard *clip= Clipboard();
    if (OnlyCopyLinks  && clip->HasFormat(CF_HTML))
    {
      int TextHandle;
      char *pText;
      std::string HTML;
      clip->Open();
      try
      {
        TextHandle = clip->GetAsHandle(CF_HTML);
        pText = (char *)GlobalLock((HGLOBAL)TextHandle);
        HTML = pText;
        GlobalUnlock((HGLOBAL)TextHandle);
        TextBuf[0]=0;
        size_t i=HTML.find_first_of("StartFragment");
        while (i<HTML.length() && HTML[i]!='>') i++;

        while ((i+6)<HTML.length())
        {
          if ( (HTML[i]!='.') && (HTML[i+1]=='h') && (HTML[i+2]=='r') && (HTML[i+3]=='e')
              && (HTML[i+4]=='f') && (HTML[i+5]=='='))
          {
            i+=6;
            if ((HTML[i]=='\'') || (HTML[i]=='"'))
              i++;
            long startpos=i;
            while ((i<HTML.length()) && (HTML[i]!='\'') && (HTML[i]!='"') && (HTML[i]!='>'))
              i++;
            if ((HTML.substr(startpos,4)!="java")
                && (HTML[startpos]!='#')
                && (HTML[startpos]!='?')
                && (HTML[startpos]!='/')
                && (HTML[startpos]!='\\')
                )
            {
              strcat(TextBuf, HTML.substr(startpos, i-startpos).c_str());
              strcat(TextBuf, "\r\n");
            }
          }
          i++;
        }
      }
      catch (...) {
      }
      clip->Close();
    } else if (clip->HasFormat(CF_TEXT))
	  {
		    clip->GetTextBuf(TextBuf, sizeof TextBuf);
        if  (StripWS || StripCR)
        {
           int endi=strlen(TextBuf)-1;
           while ( (StripWS && (*Startp==' ' || *Startp=='\t')) ||
                   (StripCR && (*Startp=='\n' || *Startp=='\r')) )
             Startp++;
           while ( (endi>0) &&
                   ( (StripWS && (TextBuf[endi]==' ' || TextBuf[endi]=='\t')) ||
                     (StripCR && (TextBuf[endi]=='\n' || TextBuf[endi]=='\r')) )
                  )
             endi--;
           TextBuf[endi+1]='\0';
        }
        /*if (OnlyCopyLinks)
        {
          char *p=strstr(Startp,"http://");
          if (p!=NULL) {
            Startp=p;
            while ((*p!='\0') && (*p!=' ')) p++;
            *p='\0';
          } else {
            char *p=strstr(Startp,"mailto:");
            if (p!=NULL) {
              Startp=p;
              while ((*p!='\0') && (*p!=' ')) p++;
              *p='\0';
            }
          }
        }
        */
	  }
	} catch (...) {
	}
  return Startp;

}

void __fastcall TClipForm1::ConvertClip()
{
	try {
	  Clipboard()->SetTextBuf(ConvertedClipboard());
	} catch (...) {
	}
}


//---------------------------------------------------------------------------
// TrayIcon Functions:
//---------------------------------------------------------------------------

 void TClipForm1::TrayIcon_Create (const char *tipText,HICON hIcon)
  {

	 NOTIFYICONDATA info;
	 memset(&info,0,sizeof(info));
	 info.cbSize          =sizeof(info) ;
	 info.hWnd            =Handle;
	 info.uID             =WM_TRAY_ICON_ID;
	 info.uCallbackMessage=WM_TRAY_ICON_MESSAGE;
	 info.hIcon           =hIcon;
	 strncpy (info.szTip,tipText,sizeof(info.szTip));
	 info.szTip[sizeof(info.szTip)-1]='0';
	 info.uFlags          =NIF_MESSAGE | NIF_ICON | NIF_TIP ;
	 Shell_NotifyIcon(NIM_ADD,&info) ;
  }


//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_ModifyTip(const char *tipText)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.uFlags          =NIF_TIP;
  strncpy(info.szTip,tipText,sizeof(info.szTip));
  info.szTip[sizeof(info.szTip)-1]='\0';
  Shell_NotifyIcon(NIM_MODIFY,&info);
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_ModifyIcon(HICON hIcon)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.hIcon           =hIcon;
  info.uFlags          =NIF_ICON;
  Shell_NotifyIcon(NIM_MODIFY,&info) ;
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_Delete(void)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize=sizeof(info);
  info.hWnd  =Handle;
  info.uID   =WM_TRAY_ICON_ID;
  Shell_NotifyIcon(NIM_DELETE,&info);
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_HandleMessage(TMessage &Message)
{
  switch (Message.LParam)
  {
	 case WM_LBUTTONDBLCLK:
		break;
	 case WM_RBUTTONDOWN:
     if (!((AboutBox->Visible) || (SetupForm->Visible)))
     {
        POINT point;
        HWND Prev;
        ::GetCursorPos(&point);
        SetForegroundWindow(Handle);

        PopupMenu1->Popup(point.x,point.y);
        Prev= GetForegroundWindow();
        SetForegroundWindow(Handle);
        SetForegroundWindow(Prev);
     }
		break;
	 case WM_RBUTTONDBLCLK:
	 case WM_MOUSEMOVE:
	 case WM_LBUTTONDOWN:
		break;
  }
}
//---------------------------------------------------------------------------
// Menu Functions:
//---------------------------------------------------------------------------

void __fastcall TClipForm1::Exit1Click(TObject *Sender)
{
	Close();
}


//---------------------------------------------------------------------------

void __fastcall TClipForm1::ChangeIcons(short set)
{
  ImageActive->Picture->Icon=AltImageActive->Picture->Icon;
  ImageInactive->Picture->Icon=AltImageInactive->Picture->Icon;
  ImageHotkey->Picture->Icon=AltImageHotkey->Picture->Icon;
  SetActive(Active1->Checked);
}


void __fastcall TClipForm1::SetActive(bool active)
{
  Active1->Checked=active;
  Timer1->Enabled=false;
	if (active) {
    if (GetRegInt("HotKeyFunction")) {
      TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Hotkey)).c_str());
      TrayIcon_ModifyIcon(ImageHotkey->Picture->Icon->Handle);
    } else {
   		TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Active)).c_str());
	  	TrayIcon_ModifyIcon(ImageActive->Picture->Icon->Handle);
      Timer1->Enabled=true;
    }
	} else {
    TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Inactive)).c_str());
    TrayIcon_ModifyIcon(ImageInactive->Picture->Icon->Handle);
	}
}

void __fastcall TClipForm1::Active1Click(TObject *Sender)
{
   SetActive(!Active1->Checked);
}

//---------------------------------------------------------------------------

void __fastcall TClipForm1::About1Click(TObject *Sender)
{
  AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TClipForm1::Options1Click(TObject *Sender)
{
  UnsetHotKey();
  if (SetupForm->ShowModal()==mrOk)
  {
  }
  StripWS=GetRegInt("StripWS");
  StripCR=GetRegInt("StripCR");
  OnlyCopyLinks=GetRegInt("OnlyCopyLinks");
  SetHotKey();
  SetActive(Active1->Checked);
}
//---------------------------------------------------------------------------


void __fastcall TClipForm1::SetHotKey()
{
  Word TheKey;
  TShiftState TheShiftState;
  UnsetHotKey();
   ShortCutToKey(SetupForm->GetHotKey(), TheKey, TheShiftState);
   if (TheKey!=0)
   {
     unsigned fsMod=0;
     if (TheShiftState.Contains(ssShift)) fsMod |= MOD_SHIFT;
     if (TheShiftState.Contains(ssCtrl)) fsMod |= MOD_CONTROL;
     if (TheShiftState.Contains(ssAlt)) fsMod |= MOD_ALT;
     RegisterHotKey(Handle, 1, fsMod, TheKey);
     HotKeySet=true;
   }
}

void __fastcall TClipForm1::UnsetHotKey()
{
  if (HotKeySet)
     UnregisterHotKey( Handle, 1 );
  HotKeySet=false;
}

void __fastcall TClipForm1::WMHotKey(TMessage &Message)
{
  if (GetRegInt("HotKeyFunction")){
     ConvertClip();
     HWND CurWin=GetForegroundWindow();
     PostMessage( CurWin, WM_KEYDOWN, VK_CONTROL, 0x1D0001 );
     PostMessage( CurWin, WM_KEYDOWN, 0x56, 0x2F0001 );
     PostMessage( CurWin, WM_KEYUP , 0x56, 0xC02F0001);
     PostMessage( CurWin, WM_KEYUP , VK_CONTROL, 0xC01D0001);
  } else
     Active1Click(this);
}


//---------------------------------------------------------------------------
// Timer:
//---------------------------------------------------------------------------
void __fastcall TClipForm1::Timer1Timer(TObject *Sender)
{
	ConvertClip();
}
//---------------------------------------------------------------------------



