//---------------------------------------------------------------------------

#include <Registry.hpp>
#pragma hdrstop

#include "winutil.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
#include <windows.h>
#include <stdio.h>



AnsiString __fastcall VersionInfo(const AnsiString &sQuery)
{
  DWORD c;
  DWORD dw=0;
  UINT ui;
  char *p;
  LPVOID ptr;
  String sOut=ParamStr(0);

  c = GetFileVersionInfoSize(ParamStr(0).c_str(), &dw);
  p = new char[c + 1];
  GetFileVersionInfo(ParamStr(0).c_str(),0,c,p);

  VerQueryValue(p, TEXT("\\VarFileInfo\\Translation"), &ptr, &ui);

  WORD *id=(WORD*)ptr;
  String sBase = String(  "\\StringFileInfo\\")+
                         IntToHex(id[0],4) +
                         IntToHex(id[1],4) +
                         "\\";
  String qs = sBase + sQuery ;
  VerQueryValue(p, qs.c_str(), &ptr, &ui);
  sOut = (char*)ptr;
  delete [] p;
  return sOut;
}


//---------------------------------------------------------------------------
// Registry Functions:
//---------------------------------------------------------------------------



int GetRegInt(AnsiString name)
{

  int i=0;
  TRegistry *Registry = new TRegistry(KEY_READ);
  try
  {
    if (Registry->KeyExists("Software")) {
       Registry->OpenKey("Software",false);
       if (Registry->KeyExists("The Hovgaard Klan")) {
         Registry->OpenKey("The Hovgaard Klan",false);
         if (Registry->KeyExists("HovText")) {
            Registry->OpenKey("HovText",false);
            if (Registry->ValueExists(name))
               i = Registry->ReadInteger(name);
         }
       }
    }
  }
  catch (...)
  {
  }
  delete Registry;
  return i;
}


void SetRegInt(AnsiString name, int i)
{
  TRegistry *Registry = new TRegistry(KEY_WRITE);
  try
  {
    Registry->OpenKey("Software",true);
    Registry->OpenKey("The Hovgaard Klan",true);
    Registry->OpenKey("HovText",true);
    Registry->WriteInteger(name, i);
  }
  catch (...)
  {
  }
  delete Registry;
}


void InstallStartup()
{
//HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run
  TRegistry *Registry = new TRegistry(KEY_WRITE);
  try
  {
    Registry->OpenKey("Software",true);
    Registry->OpenKey("Microsoft",true);
    Registry->OpenKey("Windows",true);
    Registry->OpenKey("CurrentVersion",true);
    Registry->OpenKey("Run",true);
    Registry->WriteString("HovText", ParamStr(0));
  }
  catch (...)
  {
  }
  delete Registry;
}

bool HasStartup()
{
  bool StartUp=false;
  TRegistry *Registry = new TRegistry(KEY_READ);
  try
  {
    Registry->OpenKey("Software",false);
    Registry->OpenKey("Microsoft",false);
    Registry->OpenKey("Windows",false);
    Registry->OpenKey("CurrentVersion",false);
    Registry->OpenKey("Run",false);
    StartUp=Registry->ValueExists("HovText");
  }
  catch (...)
  {
  }
  delete Registry;
  return StartUp;
}

void RemoveStartup()
{
  TRegistry *Registry = new TRegistry(KEY_WRITE);
  try
  {
    Registry->OpenKey("Software",false);
    Registry->OpenKey("Microsoft",false);
    Registry->OpenKey("Windows",false);
    Registry->OpenKey("CurrentVersion",false);
    Registry->OpenKey("Run",false);
    Registry->DeleteValue("HovText");
  }
  catch (...)
  {
  }
  delete Registry;
}

